   PROGRAM



   INCLUDE('ABFUZZY.INC'),ONCE
   INCLUDE('ABERROR.INC'),ONCE
   INCLUDE('ABFILE.INC'),ONCE
   INCLUDE('ABUTIL.INC'),ONCE
   INCLUDE('ERRORS.CLW'),ONCE
   INCLUDE('KEYCODES.CLW'),ONCE
 INCLUDE('QuickSock.INC')

   MAP
!--- Application Global and Exported Procedure Definitions --------------------------------------------
     MODULE('MYTABLEANDFORM001.CLW')
TableTest              PROCEDURE   !
     END
    ! Declare functions defined in this DLL
MyTableAndForm:Init    PROCEDURE(<ErrorClass curGlobalErrors>, <INIClass curINIMgr>)
MyTableAndForm:Kill    PROCEDURE
    ! Declare init functions defined in a different dll
     MODULE('DATA_ALL.DLL')
DATA_ALL:Init          PROCEDURE(<ErrorClass curGlobalErrors>, <INIClass curINIMgr>),DLL
DATA_ALL:Kill          PROCEDURE,DLL
     END
   END

GLO:MyFields1        STRING(20),EXTERNAL,DLL(_ABCDllMode_)
GLO:MyFields2        STRING(20),EXTERNAL,DLL(_ABCDllMode_)
GLO:Client_Name      CSTRING(21),EXTERNAL,DLL(_ABCDllMode_)
GLO:Client_Pwd       CSTRING(17),EXTERNAL,DLL(_ABCDllMode_)
GLO:Server_Name      CSTRING(21),EXTERNAL,DLL(_ABCDllMode_)
GLO:Server_Port      LONG,EXTERNAL,DLL(_ABCDllMode_)
GLO:Server_Ip        CSTRING(17),EXTERNAL,DLL(_ABCDllMode_)
BankTerm:TermJson_Response STRING(4096),EXTERNAL,DLL(_ABCDllMode_)
SilentRunning        BYTE(0)                               ! Set true when application is running in 'silent mode'

!region File Declaration
Table1               FILE,DRIVER('TOPSPEED'),PRE(Tab1),CREATE,BINDABLE,THREAD,EXTERNAL(''),DLL(dll_mode) !                     
idkey                    KEY(Tab1:id),OPT,PRIMARY          !                     
Record                   RECORD,PRE()
id                          LONG                           !                     
Name                        STRING(20)                     !                     
                         END
                     END                       

!endregion

Access:Table1        &FileManager,THREAD,EXTERNAL,DLL      ! FileManager for Table1
Relate:Table1        &RelationManager,THREAD,EXTERNAL,DLL  ! RelationManager for Table1

GlobalRequest        BYTE,EXTERNAL,DLL,THREAD              ! Exported from a dll, set when a browse calls a form, to let it know action to perform
GlobalResponse       BYTE,EXTERNAL,DLL,THREAD              ! Exported from a dll, set to the response from the form
VCRRequest           LONG,EXTERNAL,DLL,THREAD              ! Exported from a dll, set to the request from the VCR buttons
FuzzyMatcher         FuzzyClass                            ! Global fuzzy matcher
LocalErrorStatus     ErrorStatusClass,THREAD
LocalErrors          ErrorClass
LocalINIMgr          INIClass
GlobalErrors         &ErrorClass
INIMgr               &INIClass
DLLInitializer       CLASS                                 ! An object of this type is used to initialize the dll, it is created in the generated bc module
Construct              PROCEDURE
Destruct               PROCEDURE
                     END

  CODE
DLLInitializer.Construct PROCEDURE


  CODE
  LocalErrors.Init(LocalErrorStatus)
  LocalINIMgr.Init('.\MyTableAndForm.INI', NVD_INI)        ! Initialize the local INI manager to use windows INI file
  INIMgr &= LocalINIMgr
  IF GlobalErrors &= NULL
    GlobalErrors &= LocalErrors                            ! Assign local managers to global managers
  END
  FuzzyMatcher.Init                                        ! Initilaize the browse 'fuzzy matcher'
  FuzzyMatcher.SetOption(MatchOption:NoCase, 1)            ! Configure case matching
  FuzzyMatcher.SetOption(MatchOption:WordOnly, 0)          ! Configure 'word only' matching
  
!These procedures are used to initialize the DLL. It must be called by the main executable when it starts up
MyTableAndForm:Init PROCEDURE(<ErrorClass curGlobalErrors>, <INIClass curINIMgr>)
MyTableAndForm:Init_Called    BYTE,STATIC

  CODE
  IF MyTableAndForm:Init_Called
     RETURN
  ELSE
     MyTableAndForm:Init_Called = True
  END
  IF ~curGlobalErrors &= NULL
    GlobalErrors &= curGlobalErrors
  END
  IF ~curINIMgr &= NULL
    INIMgr &= curINIMgr
  END
  Access:Table1.SetErrors(GlobalErrors)
  DATA_ALL:Init(curGlobalErrors, curINIMgr)                ! Initialise dll - (ABC) -

!This procedure is used to shutdown the DLL. It must be called by the main executable before it closes down

MyTableAndForm:Kill PROCEDURE
MyTableAndForm:Kill_Called    BYTE,STATIC

  CODE
  IF MyTableAndForm:Kill_Called
     RETURN
  ELSE
     MyTableAndForm:Kill_Called = True
  END
  DATA_ALL:Kill()                                          ! Kill dll - (ABC) -
  

DLLInitializer.Destruct PROCEDURE

  CODE
  FuzzyMatcher.Kill                                        ! Destroy fuzzy matcher
  LocalINIMgr.Kill                                         ! Kill local managers and assign NULL to global refernces
  INIMgr &= NULL                                           ! It is an error to reference these object after this point
  GlobalErrors &= NULL


