

   MEMBER('MyTableAndForm.clw')                            ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABEIP.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('MYTABLEANDFORM001.INC'),ONCE        !Local module procedure declarations
                     END


!!! <summary>
!!! Generated from procedure template - Browse
!!! </summary>
TableTest PROCEDURE 

LOC:ToUserName       CSTRING(21)                           ! 
LOC:QueueOfData      GROUP,PRE()                           ! 
ClientAddress        STRING(250)                           ! 
ClientName           STRING(20)                            ! 
ClientId             LONG                                  ! 
                     END                                   ! 
LOC:Error            LONG                                  ! 
LOC:NotificationCode LONG                                  ! 
LOC:MessageOut       CSTRING(501)                          ! 
lQUsers              QUEUE,PRE()                           ! 
UserName             CSTRING(21)                           ! 
                     END                                   ! 
lQMessage            QUEUE,PRE(LQM)                        ! 
MessageFrom          CSTRING(101)                          ! 
MessageText          CSTRING(256)                          ! 
MessageDate          LONG                                  ! 
MessageTime          LONG                                  ! 
                     END                                   ! 
!EasySock            CLASS(EasySocketClass)
!TakeWindowMessage         PROCEDURE(LONG client, LONG request),PROTECTED,DERIVED
!!OnClientConnect           PROCEDURE(LONG client),PROTECTED,DERIVED
!!OnClientClosed            PROCEDURE(LONG client),PROTECTED,DERIVED
!                    END
BRW1::View:Browse    VIEW(Table1)
                       PROJECT(Tab1:id)
                       PROJECT(Tab1:Name)
                     END
Queue:Browse         QUEUE                            !Queue declaration for browse/combo box using ?List
Tab1:id                LIKE(Tab1:id)                  !List box control field - type derived from field
Tab1:Name              LIKE(Tab1:Name)                !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(10000)                  !Entry's view position
                     END
BrowseWindow         WINDOW('Browse Records'),AT(0,0,247,140),GRAY,SYSTEM
                       LIST,AT(5,5,235,100),USE(?List),HVSCROLL,FORMAT('60L(2)|M~id~L(1)@n-14@80L(2)|M~Name~L(0)@s20@'), |
  FROM(Queue:Browse),IMM,MSG('Browsing Records')
                       BUTTON('&Insert'),AT(5,110,40,12),USE(?Insert)
                       BUTTON('&Change'),AT(50,110,40,12),USE(?Change),DEFAULT
                       BUTTON('&Delete'),AT(95,110,40,12),USE(?Delete)
                       BUTTON('&Select'),AT(145,110,40,12),USE(?Select)
                       BUTTON('Close'),AT(200,110,40,12),USE(?Close)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?List
Q                      &Queue:Browse                  !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
                     END

BRW1::EIPManager     BrowseEIPManager                      ! Browse EIP Manager for Browse using ?List
EditInPlace::Tab1:Name EditEntryClass                      ! Edit-in-place class for field Tab1:Name
Socket              CLASS(QuickAppConnectClass)
Event_ServerResponse      PROCEDURE(LONG pOriginalCommand, LONG pRetVal, STRING pRetMsg),PROTECTED,DERIVED !Called in the client after a call to methods like Login, Message, Broadcast, etc. the info come from the server response
Event_LoginOnServer       PROCEDURE(STRING pUserName, STRING pUserPassword, *BYTE pCancelOperation),PROTECTED,DERIVED
Event_Message             PROCEDURE(STRING pFromUserName, STRING pToUserName, STRING pMsgText),PROTECTED,DERIVED
Event_Notification        PROCEDURE(STRING pFromUserName, STRING pToUserName, LONG pNotificationCode, STRING pMsgText),PROTECTED,DERIVED
Event_BroadcastNotification PROCEDURE(STRING pFromUserName, LONG pNotificationCode, STRING pMsgText),PROTECTED,DERIVED
Event_BroadcastShutdown   PROCEDURE(STRING pFromUserName, LONG pNotificationCode, STRING pMsgText),PROTECTED,DERIVED
Event_NotifyDisconnected  PROCEDURE(STRING pUserName),PROTECTED,DERIVED
Event_NotifyConnected     PROCEDURE(STRING pUserName),PROTECTED,DERIVED
Event_NotifyCleanConnected PROCEDURE(),PROTECTED,DERIVED
                    END

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------
InitializeServerInfo ROUTINE
  IF CLIP(GLO:Server_Ip)=''
     GLO:Server_Name = Socket.GetMachineName()
     GLO:Server_Ip   = Socket.GetMachineIpAddress()
     GLO:Server_Port = 8088
  END
StartServer ROUTINE
!?ResetServerInfoButton
    IF Socket.IsServerRunning()= false
        LOC:Error = Socket.StartServer(GLO:Server_Ip,GLO:Server_Port,GLO:Server_Name)
        IF NOT LOC:Error
!           ?StartServerButton{PROP:Disable} = TRUE
!           ?StopServerButton{PROP:Disable} = False
!           ?ResetServerInfoButton{PROP:Disable} = TRUE
!           ?ServerInfGroup{PROP:Disable} = TRUE
!           
!           !Disable to Client too
!           ?StartClientButton{PROP:Disable} = TRUE
!           ?StopClientButton{PROP:Disable} = TRUE
!           
!           ?ClientInfoGROUP{PROP:Disable}=true
!           
!          ?SendButton{PROP:Disable} = false
!          ?BrodcastNotifyButton{PROP:Disable} = false
!          ?BrodcastShutdownButton{PROP:Disable} = false
!          ?NotifyButton{PROP:Disable} = false
!          
!          0{PROP:Text} = 'Chat Server ('&GLO:Server_Name&')'
!          SELECT(?TABClient)
        ELSE
!           MESSAGE('The server couldn''t start|Error: '&LOC:Error)
!           ?StartServerButton{PROP:Disable} = False
!           ?StopServerButton{PROP:Disable} = TRUE
!           ?ResetServerInfoButton{PROP:Disable} = false
!           ?ServerInfGroup{PROP:Disable} = false
!           
!           !Enable client
!           ?StartClientButton{PROP:Disable} = false
!           ?StopClientButton{PROP:Disable} = TRUE
!           ?ClientInfoGROUP{PROP:Disable}=false
!
!          ?SendButton{PROP:Disable} = true
!          ?BrodcastNotifyButton{PROP:Disable} = true
!          ?BrodcastShutdownButton{PROP:Disable} = true
!          ?NotifyButton{PROP:Disable} = true
!          
!          0{PROP:Text} = 'Chat (Not Connected)'
        END
    END
StopServer ROUTINE
    IF Socket.IsServerRunning()
        Socket.StopServer()
        CLEAR(lQMessage)
        CLEAR(lQUsers)         
        
!        ?StartServerButton{PROP:Disable} = False
!        ?StopServerButton{PROP:Disable} = TRUE
!        ?ResetServerInfoButton{PROP:Disable} = false
!        ?ServerInfGroup{PROP:Disable} = false
!        
!        !Enable client
!        ?StartClientButton{PROP:Disable} = false
!        ?StopClientButton{PROP:Disable} = TRUE
!        ?ClientInfoGROUP{PROP:Disable} = false
!
!        ?SendButton{PROP:Disable} = true
!        ?BrodcastNotifyButton{PROP:Disable} = true
!        ?BrodcastShutdownButton{PROP:Disable} = true
!        ?NotifyButton{PROP:Disable} = true
!        
!        0{PROP:Text} = 'Chat (Not Connected)'
    END
ConnectToServer ROUTINE
    IF Socket.IsServerRunning() = FALSE
       IF NOT Socket.ConnectTo(GLO:Server_Ip ,GLO:Server_Port)
!          !Disable connection
!          ?StartClientButton{PROP:Disable} = TRUE
!          ?StopClientButton{PROP:Disable} = false
!          ?ClientInfoGROUP{PROP:Disable}=true
!          ?ServerInfGroup{PROP:Disable} = true
!          
!          !server disable
!          ?StartServerButton{PROP:Disable} = true
!
!          ?SendButton{PROP:Disable} = false
!          ?BrodcastNotifyButton{PROP:Disable} = false
!          ?BrodcastShutdownButton{PROP:Disable} = false
!          ?NotifyButton{PROP:Disable} = false

!          0{PROP:Text} = 'Chat Client ('& GLO:Client_Name &')'
          IF Socket.Login(GLO:Client_Name,GLO:Client_Pwd)
             Do ConnectionFail
             MESSAGE('The Login fail to send.')
          ELSE
             !SELECT(?TABClient)
          END
       ELSE
          Do ConnectionFail
          MESSAGE('The Client couldn''t start.')
       END       
    END
ConnectionFail ROUTINE
          !It fails, enable connection
!          ?StartClientButton{PROP:Disable} = false
!          ?StopClientButton{PROP:Disable} = true
!          ?ServerInfGroup{PROP:Disable} = false
!          ?ClientInfoGROUP{PROP:Disable}=false
!          
!
!          ?StartServerButton{PROP:Disable} = false
!          ?SendButton{PROP:Disable} = true
!          ?BrodcastNotifyButton{PROP:Disable} = true
!          ?BrodcastShutdownButton{PROP:Disable} = true
!          ?NotifyButton{PROP:Disable} = true
!          
!          0{PROP:Text} = 'Chat (Not Connected)'
 EXIT

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('TableTest')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?List
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.AddItem(Toolbar)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:Table1.Open                                       ! File Table1 used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?List,Queue:Browse.ViewPosition,BRW1::View:Browse,Queue:Browse,Relate:Table1,SELF) ! Initialize the browse manager
  SELF.Open(BrowseWindow)                                  ! Open window
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse
  BRW1.AddSortOrder(,)                                     ! Add the sort order for  for sort order 1
  BRW1.AddField(Tab1:id,BRW1.Q.Tab1:id)                    ! Field Tab1:id is a hot field or requires assignment from browse
  BRW1.AddField(Tab1:Name,BRW1.Q.Tab1:Name)                ! Field Tab1:Name is a hot field or requires assignment from browse
  INIMgr.Fetch('TableTest',BrowseWindow)                   ! Restore window settings from non-volatile store
  BRW1.AddToolbarTarget(Toolbar)                           ! Browse accepts toolbar control
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Table1.Close
  END
  IF SELF.Opened
    INIMgr.Update('TableTest',BrowseWindow)                ! Save window data to non-volatile store
  END
  
  GlobalErrors.SetProcedureName
  RETURN ReturnValue

!EasySock.TakeWindowMessage  PROCEDURE(LONG client, LONG request)
!CODE
!    !MESSAGE('TakeWindowMessage: ' & EasySock.bufferReceived)
!
!    !glo:response = glo:response & EasySock.bufferReceived
!    BankTerm:TermJson_Response = EasySock.bufferReceived
!    BankTerm:TermJson_Response = CLIP(BankTerm:TermJson_Response) & '\\rn'
!
!    !MESSAGE('glo:response: ' & glo:response)
!    
!   ! DO ParseJson       
!    
Socket.Event_ServerResponse      PROCEDURE(LONG pOriginalCommand, LONG pRetVal, STRING pRetMsg)
 CODE
    !MESSAGE('pOriginalCommand=('&pOriginalCommand&') '&Socket._CommandToString(pOriginalCommand)&'|pRetVal:'&pRetVal&'|pRetMsg:'&pRetMsg)
    CASE pOriginalCommand
    OF QuickSocketCmd:Login
       IF pRetVal<>0
          Do ConnectionFail
       !ELSE
       !   MESSAGE('Login ok: '&pRetMsg)
       END
    OF QuickSocketCmd:SendMessage
    OF QuickSocketCmd:SendData
    OF QuickSocketCmd:SendNotify
    OF QuickSocketCmd:BroadcastNotify
    OF QuickSocketCmd:BroadcastShutdown
    OF QuickSocketCmd:NotifyConnected
    OF QuickSocketCmd:NotifyDisconnected
    OF QuickSocketCmd:CmdAnswer  
    END    
Socket.Event_LoginOnServer        PROCEDURE(STRING pUserName, STRING pUserPassword, *BYTE pCancelOperation)
 CODE
    !Verify that the pUserName and pUserPassword are correct
    IF UPPER(pUserName) = 'GUEST' !Do not allow a GUEST user
       pCancelOperation = true
    END
    PARENT.Event_LoginOnServer(pUserName, pUserPassword, pCancelOperation)
    IF pCancelOperation
    !   MESSAGE('the log in was cancelled by the server')    
    ELSE
     !  MESSAGE('A user has logged in using |User Name: '&pUserName&'|Password: '&pUserPassword,'Login Received')    
    END
    
Socket.Event_Message             PROCEDURE(STRING pFromUserName, STRING pToUserName, STRING pMsgText)
 CODE
    lQMessage.MessageFrom = 'From '&pFromUserName &' to '&pToUserName
    lQMessage.MessageText = pMsgText
    lQMessage.MessageDate = TODAY()
    lQMessage.MessageTime = CLOCK()
    ADD(lQMessage)
    
Socket.Event_Notification        PROCEDURE(STRING pFromUserName, STRING pToUserName, LONG pNotificationCode, STRING pMsgText)
 CODE
    IF pNotificationCode = 999 !We use an special notification code to know that we sent a group
     LOC:NotificationCode = 999
     SELF.JSON.FromJSON(pMsgText,LOC:QueueOfData)
    lQMessage.MessageFrom = 'ClientInfo From '&pFromUserName &' to '&pToUserName
    lQMessage.MessageText = 'Id='&LOC:QueueOfData.ClientId&', Name='&LOC:QueueOfData.ClientName&', Address='&CLIP(LOC:QueueOfData.ClientAddress)
    lQMessage.MessageDate = TODAY()
    lQMessage.MessageTime = CLOCK()
    ADD(lQMessage)
    END
    
Socket.Event_BroadcastNotification PROCEDURE(STRING pFromUserName, LONG pNotificationCode, STRING pMsgText)
 CODE
    lQMessage.MessageFrom = 'Notification From '&pFromUserName &' to ALL'
    lQMessage.MessageText = '('&pNotificationCode&') '&pMsgText
    lQMessage.MessageDate = TODAY()
    lQMessage.MessageTime = CLOCK()
    ADD(lQMessage)
    
Socket.Event_BroadcastShutdown   PROCEDURE(STRING pFromUserName, LONG pNotificationCode, STRING pMsgText)
 CODE
    MESSAGE('The user: '&pFromUserName&' is requesting to shutdown the app|Code:'&pNotificationCode&'|'&pMsgText,'Shutdown Request')
Socket.Event_NotifyDisconnected  PROCEDURE(STRING pUserName)
 CODE
    CLEAR(lQUsers)
    lQUsers.UserName = pUserName
    GET(lQUsers,lQUsers.UserName)
    IF NOT ERRORCODE()       
       DELETE(lQUsers)
    END    
    DISPLAY()
   ! MESSAGE('User '&pUserName&' Disconnected')
Socket.Event_NotifyConnected     PROCEDURE(STRING pUserName)
lIndex LONG
 CODE
    CLEAR(lQUsers)  
    lQUsers.UserName = pUserName
    ADD(lQUsers)    
    DISPLAY()
    !MESSAGE('User '&pUserName&' Connected')
Socket.Event_NotifyCleanConnected PROCEDURE()
 CODE
    CLEAR(lQUsers)
    FREE(lQUsers)
    DISPLAY()
 

BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  SELF.SelectControl = ?Select
  SELF.HideSelect = 1                                      ! Hide the select button when disabled
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  SELF.EIP &= BRW1::EIPManager                             ! Set the EIP manager
  SELF.AddEditControl(,1) ! Tab1:id Disable
  SELF.AddEditControl(EditInPlace::Tab1:Name,2)
  SELF.DeleteAction = EIPAction:Always
  SELF.ArrowAction = EIPAction:Default+EIPAction:Remain+EIPAction:RetainColumn
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert
    SELF.ChangeControl=?Change
    SELF.DeleteControl=?Delete
  END

