  MEMBER('data_all.clw')

  INCLUDE('ABFILE.INC'),ONCE

  MAP
data_all_BC0:DctInit    PROCEDURE()
data_all_BC0:DctKill    PROCEDURE()
data_all_BC0:FilesInit  PROCEDURE()
  END

Hide:Access:Table1   CLASS(FileManager),TYPE               ! FileManager for Table1
Init                   PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED
                     END


Hide:Relate:Table1   CLASS(RelationManager),TYPE           ! RelationManager for Table1
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END


_Hide:Access:Table1  &Hide:Access:Table1,AUTO,THREAD
_Hide:Relate:Table1  &Hide:Relate:Table1,AUTO,THREAD


data_all_BC0:DctInit PROCEDURE()
  CODE
  _Hide:Access:Table1 &= NEW(Hide:Access:Table1)
  _Hide:Relate:Table1 &= NEW(Hide:Relate:Table1)
  Relate:Table1 &= _Hide:Relate:Table1


data_all_BC0:FilesInit PROCEDURE()
  CODE
  _Hide:Relate:Table1.Init


data_all_BC0:DctKill PROCEDURE()
  CODE
  _Hide:Relate:Table1.Kill
  DISPOSE(_Hide:Relate:Table1)


Hide:Relate:Table1.Init PROCEDURE()
  CODE
  _Hide:Access:Table1.Init
  SELF.Init(Access:Table1,1)


Hide:Access:Table1.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= Tab1:Record
  SELF.FileNameValue = 'Table1'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= Table1
  PARENT.Init
  Access:Table1 &= SELF


Hide:Access:Table1.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:Table1 &= NULL                                    ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:Table1.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(Table1,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
    SELF.AddKey(Tab1:idkey,'Tab1:idkey',1)
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Relate:Table1.Kill PROCEDURE

  CODE
  _Hide:Access:Table1.Kill                                 ! Kill the file manager
  PARENT.Kill
  Relate:Table1 &= NULL                                    ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:Table1)                             ! destroy the file manager

